#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum{crvena,crna};

typedef struct stablo
{
	char uboja[10];
	char oblik[10];
	int boja;
	struct stablo *levi, *desni, *roditelj;
} stablo;

#define novi(x) x = (stablo*)malloc(sizeof(stablo))

int broj(stablo *p, char *s)
{
	int br = 0;
	if(p != NULL)
	{
		broj(p->levi, s);
		if(!strcmp(p->uboja, s))
			return ++br;
		else
			return 0;
		broj(p->desni, s);
	}
	return;
}

void lrotacija(stablo **p)
{
	stablo *x, *y;
	
	x = *p;
	y = x->desni;
	
	x->desni = y->levi;
	if(y->levi)
		y->levi->roditelj = x;
		
	y->roditelj = x->roditelj;
	if(x->roditelj)
		if(x == x->roditelj->levi) x->roditelj->levi = y;
		else
			x->roditelj->desni = y;
			
	x->roditelj = y;
	y->levi = x;
	
	*p = y;
}

void drotacija(stablo **p)
{
	stablo *x, *y;
	
	x = *p;
	y = x->levi;
	
	x->levi = y->desni;
	if(y->desni)
		y->desni->roditelj = x;
    
    y->roditelj = x->roditelj;
    if(x->roditelj)
		if(x == x->roditelj->levi)
			x->roditelj->levi = y;
		else
			x->roditelj->desni = y;
	
	x->roditelj = y;
	y->desni = x;
	
	*p = y;
}

void stampaj(stablo *p)
{
	if(p != NULL)
	{
		stampaj(p->levi);
		printf("%s %s ", p->uboja, p->oblik);
		if(p->boja == crvena)
			printf("crvena\n");
		else
			printf("crna\n");
		stampaj(p->desni);
	}
}

void bojefix(stablo **p, stablo *z)
{
	stablo *x, *y;
	
	while((z->roditelj) && (z->roditelj->boja == crvena))
	{
		if(z->roditelj == z->roditelj->roditelj->levi)
		{
			y = z->roditelj->roditelj->desni;
			if((y) && (y->boja == crvena))
			{
				z->roditelj->boja = crna;
				y->boja = crna;
				z->roditelj->roditelj->boja = crvena;
				z = z->roditelj->roditelj;
			}
			else
			{
				if(z == z->roditelj->desni)
				{
					z = z->roditelj;
					drotacija(&z);
					if(!z->roditelj)
						*p = z;
					z = z->levi;
				}
				z->roditelj->boja = crna;
				z->roditelj->roditelj->boja = crvena;
				x = z->roditelj->roditelj;
				drotacija(&x);
				if(!x->roditelj)
					*p = x;	
			}
		}
		else
		{
			y = z->roditelj->roditelj->levi;
			if((y) && (y->boja == crvena))
			{
				z->roditelj->boja = crna;
				y->boja = crna;
				z->roditelj->roditelj->boja = crvena;
				z = z->roditelj->roditelj;
			}
			else
			{
				if(z == z->roditelj->levi)
				{
					z = z->roditelj;
					lrotacija(&z);
					if(!z->roditelj)
						*p = z;
					z = z->desni;
				}
				z->roditelj->boja = crna;
				z->roditelj->roditelj->boja = crvena;
				x = z->roditelj->roditelj;
				lrotacija(&x);
				if(!x->roditelj)
					*p = x;	
			}
		}	
	}
	(*p)->boja = crna;
}

int poredi(stablo *p, stablo *q)
{
	char s1[10], s2[10];
	
	strcpy(s1, p->uboja);
	strcpy(s2, q->uboja);
	
	if(strcmp(s1, s2) != 0)
	{
		if((strcmp(s1, "srebrna") == 0)) return -1;
		if((strcmp(s2, "srebrna") == 0)) return 1;
		if((strcmp(s1, "zlatna") == 0)) return 1;
		return -1;
	}
	else
	{
		strcpy(s1, p->oblik);
		strcpy(s2, q->oblik);
		if(strcmp(s1, s2) != 0)
		{
			if(strcmp(s1, "kocka")) return 1;
			else return -1;
		}
		return 0;
	}
}

void dodaj(stablo **p, stablo *temp)
{
	stablo *x, *y;
	
	x = *p;
	y = NULL;
	
	while(x)
	{
		y = x;
		if(poredi(temp, x) > 0)
			x = x->desni;
		else
			x = x->levi;
	}
	temp->roditelj = y;
	if(!y)
		*p = temp;
	else
	{
		if(poredi(temp, y) > 0)
			y->desni = temp;
		else 
			y->levi = temp;
	}
	bojefix(p, temp);
}

void brisi(stablo **p, stablo *q, char s[10])
{
	stablo *pom;
	
	if(q != NULL)
	{
		if(strcmp(q->oblik, s) != 0)
		{
			novi(pom);
			strcpy(pom->uboja, q->uboja);
			strcpy(pom->oblik, q->oblik);
			pom->roditelj = NULL;
			pom->levi = pom->desni = NULL;
			dodaj(p, pom);
			brisi(p, q->levi, s);
			brisi(p, q->desni, s);
		}
		else
		{
			brisi(p, q->levi, s);
			brisi(p, q->desni, s);
		}
	}
	else return;
}



stablo* form()
{
	stablo *p = NULL, *temp;
	int i, n; char s[10];
	
	printf("Unesite broj clanova stabla.\n");
	scanf("%d", &n);
	getchar();
	
	for(i = 0; i < n; i++)
	{
		novi(temp);
		printf("Unesite clan stabla.\n");
		gets(s);
		strcpy(temp->uboja, s);
		gets(s);
		strcpy(temp->oblik, s);
		dodaj(&p, temp);
	}
	
	return p;
}

main()
{
	 stablo *p, *q = NULL;
	 int bl = 0; int bd = 0; char s[10];
	 
	 p = form();
	 stampaj(p);
	 
	 printf("\n\n");
	 
	 printf("Oblik na vrhu je: %s.\n", p->oblik);
	 brisi(&q, p, p->oblik);
	 if(q != NULL)
	   stampaj(q);
	 
	 printf("Boja ukrasa na vrhu je: %s.\n", q->uboja);
	 /*if(q->levi)
		bl = broj(q->levi, q->uboja);
	 if(q->desni)
		bd = broj(q->desni, q->uboja);*/

	 
	 if(bl > bd)
		printf("Vise ukrasa iste boje ima sa leve strane.\n");
	else if(bl < bd)
		printf("Vise ukrasa iste boje ima sa desne strane.\n");	 
	else 
		printf("Jednaki su.\n");
}
