#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define novi(x) x=(struct u*)malloc(sizeof(struct u))

/*ENUM boja
{
	crvena 1,
	srebrna 2,
	zlatna 3
};

ENUM oblik
{
	sfera 4,
	kocka 5
};*/

typedef struct u
{
	char *boja;
	char *oblik;
	int balans;
	struct u *levi, *desni;
}ukras;

void drotacija(ukras **p)
{
	ukras *poml, *pomd = *p;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*p = poml;
	
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
}

void lrotacija(ukras **p)
{
	ukras *poml = *p, *pomd;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*p = pomd;
	
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
}

int dubina(ukras *p)
{
	int dl = 0;
	int dd = 0;
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if (dl > dd)
		return dl++;
		else return dd++;
	}
	else return 0;
}

char nadji(ukras **p)
{
	ukras *pom;
	char rez[6];
	pom = *p;
	if(!pom->levi)
	{
		strcpy(rez,pom->oblik);
		pom = pom->desni;
	}
	else rez=nadji(&(pom->levi));
	if(pom)
	{
		pom->balans = dubina(pom->desni) - dubina(pom->levi)
		sredi(&pom);
	}
	*p = pom;
	return rez;
}

void sredi(ukras **p)
{
	ukras *t;
	if(*p)
	t = *p;
	if(t->balans < -1)
	{
		if (t->levi->balans < 0) drotacija(&t);
		else 
		{
			lrotacija(&(t->levi));
			drotacija(&t);
		}
	}
	else if(t->balans > 1)
	{
		if (t->desni->balans > 0) lrotacija(&t);
		else 
		{
			drotacija(&(t->desni));
			lrotacija(&t);
		}
	}
	*p = t;
}

ukras* obrisi(ukras *p, char *k)
{
	ukras *pom;
	if(!p) return NULL;
	if(p->broj == k)
	{
		if((!p->levi) && (!p->desni))
		{
			free(p);
			return NULL;
		}
		if((!p->levi) && (p->desni))
		{
			pom = p->desni;
			free(p);
			return pom;
		}
		if((p->levi) && (!p->desni))
		{
			pom = p->levi;
			free(p);
			return pom;
		}
		if((p->levi) && (p->desni))
		{
			p->broj = nadji(&(p->desni));
			p->balans = dubina(p->desni) - dubina(p->levi);
			sredi(&p);
			return p;
		}
	}
	if(k < p->broj)
	{
		p->levi = obrisi(p->levi, k);
		p->balans = dubina(p->desni) - dubina(p->levi);
		sredi(&p);
		return p;
	}
	else
	{
		p->desni = obrisi(p->desni, k);
		p->balans = dubina(p->desni) - dubina(p->levi);
	}
}

int uporediBoje(char *bojaUkrasaUstablu, char *bojaUkrasaZaDodavanje)//vraca 1 ako je prvi argument veci, -1 ako je 2. veci, i 0 ako su jednaki
{
	char *temp1, *temp2;
	temp1 = (char*)malloc(strlen(bojaUkrasaUstablu)+1);
	strcpy(temp1, bojaUkrasaUstablu);
	temp2 = (char*)malloc(strlen(bojaUkrasaZaDodavanje)+1);
	strcpy(temp2, bojaUkrasaZaDodavanje);
	if (((strcmp(temp1, 'srebrna') == 0) && (strcmp(temp2, 'crvena') == 0)) || ((strcmp(temp1, 'srebrna') == 0) && (strcmp(temp2, 'zlatna') == 0)) || ((strcmp(temp1, 'crvena') == 0) && (strcmp(temp2, 'zlatna') == 0)))
	return 1;
	else if (((strcmp(temp1, 'zlatna') == 0) && (strcmp(temp2, 'crvena') == 0)) || ((strcmp(temp1, 'zlatna') == 0) && (strcmp(temp2, 'srebrna') == 0)) || ((strcmp(temp1, 'crvena') == 0) && (strcmp(temp2, 'srebrna') == 0)))
	return -1;
	else return 0;
}

int uporediOblik(char *oblikUkrasaUstablu, char *oblikUkrasaZaDodavanje)//vraca 1 ako je prvi argument veci, -1 ako je 2. veci, i 0 ako su jednaki
{
	char *temp1, *temp2;
	temp1 = (char*)malloc(strlen(oblikUkrasaUstablu)+1);
	strcpy(temp1, bojaUkrasaUstablu);
	temp2 = (char*)malloc(strlen(oblikUkrasaZaDodavanje)+1);
	strcpy(temp2, bojaUkrasaZaDodavanje);
	if ((strcmp(temp1, 'sfera') == 0) && (strcmp(temp2, 'kocka') == 0))
	return 1;
	else if ((strcmp(temp1, 'kocka') == 0) && (strcmp(temp2, 'sfera') == 0))
	return -1;
	else return 0;
}

int dodaj(ukras **p, ukras *noviUkras)
{
	int rezultat = 0, inkrement;
	ukras *temp = *p;
	if(temp == NULL)
	{
		temp->boja = (char*)malloc(strlen(noviUkras->boja)+1);
		strcpy(temp->boja, noviUkras->boja);
		
		temp->oblik = (char*)malloc(strlen(noviUkras->oblik)+1);
		strcpy(temp->oblik, noviUkras->oblik);
		
		temp->balans = 0;
		temp->levi = temp->desni = NULL;
	}
	else
	{
			if (uporediBoje(p->boja,temp->boja) == 1) inkrement = -dodaj(&(p->levi), temp);
			else if(uporediBoje(p->boja,temp->boja) == -1) inkrement = dodaj(&(p->desni), temp);
			else if(uporediBoje(p->boja,temp->boja) == 0)
			{
				if (uporediOblik(p->oblik,temp->oblik) == 1) inkrement = -dodaj(&(p->levi), temp);
				else if(uporediOblik(p->oblik,temp->oblik) == -1) inkrement = dodaj(&(p->desni), temp);
				else inkrement = dodaj(&(p->desni), temp);
			}
			temp->balans += inkrement;
			if (inkrement != 0 && temp->balans != 0)
			{
				if (temp->balans > 1)
				{
					if (temp->desni->balans > 0) lrotacija(&temp);
					else
					{
						drotacija(&(temp->desni));
						lrotacija(&temp);
					}
				}
				else if (temp->balans < -1)
				{
					if (temp->levi->balans < 0) drotacija(&temp);
					else
					{
						lrotacija(&(temp->levi));
						drotacija(&temp);
					}
				}
				else rezultat = 1;
			} 
	}
	*p = temp;
	return rezultat;
}

ukras* form()
{
	int i,broj;
	ukras *koren = NULL, *tempUkras;
	char *tempBoja;
	char *tempOblik;
	scanf("Unesi broj ukrasa: \n", &broj);
	for (i = 0;i<broj;i++)
	{
		scanf("unesi boju ukrasa: \n", &tempBoja);
		koren->boja = (char*)malloc(strlen(tempBoja)+1);
		strcpy(tempUkras->boja,tempBoja);
		scanf("unesi oblik ukrasa: \n", &tempOblik);
		koren->oblik = (char*)malloc(strlen(tempOblik)+1);
		strcpy(tempUkras->oblik,tempOblik);
		dodaj(&koren, tempUkras);
	}
	
	
}

void ispis(ukras *u)
{
	if (u)
	{
		if(u->desni) ispis(u->desni);
		printf("Ukras boje %s, oblika %s \n", u->boja, u->oblik);
		if(u->levi) ispis(u->levi);
	}
}

main()
{
	ukras *u;
	char tempZaBrisanje[7];
	u = form();
	ispis(u);
	printf("unesi boju za brisanje: \n");
	scanf("%s", &tempZaBrisanje);
	obrisi(&u,tempZaBrisanje)
}
