#include<stdio.h>
#include<string.h>
#include<stdlib.h>

enum{CRVENA,CRNA};

typedef struct drvo {
	int boja ;
	struct drvo *levi,*desni,*roditelj;
	char farba[50],oblik[50];
}drvo;

#define novi(x) x = (drvo*)malloc(sizeof(drvo))

void lrotacija(drvo **t){
	drvo *x,*y;
	x = *t;
	y = x->desni;
	x->desni = y->levi;
	if(y->levi ) y->levi->roditelj = x;
	y->roditelj = x->roditelj;
	if(x->roditelj){
		if(x == x->roditelj->levi) x->roditelj->levi = y;
		else x->roditelj->desni = y;
	}
	x->roditelj = y;
	y->levi = x;
	*t = y;
}
void drotacija( drvo **t){
	drvo *x,*y;
	y = *t;
	x = y->levi;
	y->levi = x->desni;
	if(x->desni) x->desni->roditelj = y;
	x->roditelj = y->roditelj;
	if(y->roditelj ) {
		if(y == y->roditelj->levi) y->roditelj->levi = x;
		else y->roditelj->desni = x;
	}
	y->roditelj = x;
	x->desni = y;
	*t = x;
}
void bojefix(drvo **p,drvo *z){
	drvo *y,*t;
	while((z->roditelj) && (z->roditelj->boja == CRVENA)){
		if(z->roditelj == z->roditelj->roditelj->levi){
			y = z->roditelj->roditelj->desni;
			if((y) && (y->boja == CRVENA)){
				z->roditelj->boja = CRNA;
				y->boja = CRNA;
				y->roditelj->boja = CRVENA;
				z = z->roditelj->roditelj;
			}
			else{
				if(z == z->roditelj->desni){
					z = z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) *p = z;
					z = z->levi;
				}
				t = z->roditelj->roditelj;
				z->roditelj->boja = CRNA;
				t->boja = CRVENA;
				drotacija(&t);
				if(!t->roditelj) *p = t;
			}
		}
		else{
			y = z->roditelj->roditelj->levi;
			if((y) && (y->boja == CRVENA)){
				z->roditelj->boja = CRNA;
				y->boja = CRNA;
				y->roditelj->boja = CRVENA;
				z = z->roditelj->roditelj;
			}
			else{
				if(z == z->roditelj->levi){
					z = z->roditelj;
					drotacija(&z);
					if(!z->roditelj) *p = z;
					z = z->desni;
				}
				t = z->roditelj->roditelj;
				z->roditelj->boja = CRNA;
				t->boja = CRVENA;
				lrotacija(&t);
				if(!t->roditelj) *p = t;
			}
		}
	}
	(*p)->boja = CRNA;
}
int poredi(drvo *s,drvo * p){
	int xboja,xoblik,yboja,yoblik;
	if(!strcmp(s->farba,"srebrna")) xboja = 1;
	else if(!strcmp(s->farba,"crvena")) xboja = 2;
	else xboja = 3;
	if(!strcmp(s->oblik,"sfera")) xoblik = 1;
	else xoblik = 2;
	
	if(!strcmp(p->farba,"srebrna")) yboja = 1;
	else if(!strcmp(p->farba,"crvena")) yboja = 2;
	else yboja = 3;
	if(!strcmp(p->oblik,"sfera")) yoblik = 1;
	else yoblik = 2;
	
	if (xboja < yboja) return -1;
	else if((xboja == yboja) && (xoblik < yoblik)) return -1;
	else if((xboja == yboja) && (xoblik == yoblik)) return 0;
	else return 0;
}
	
void dodaj(drvo **p,drvo *z){
	drvo *x,*y;
	x = *p;
	y = NULL;
	while(x){
		y = x;
		if(poredi(z,x) == -1) x = x->levi;
		else x = x->desni;
	}
	z->roditelj = y;
	if(!y) *p = z;
	else{
		if(poredi(z,y) == -1) y->levi = z;
		else y->desni = z;
	}
	bojefix(p,z);
}
drvo * form(){
	drvo *koren=NULL,*cvor;
	int n,i;
	scanf("%d",&n);
	for(i = 0;i < n;i++){
		novi(cvor);
		cvor->levi = cvor->desni = NULL;
		cvor->boja = CRVENA;
		scanf("%s",cvor->farba);
		scanf("%s",cvor->oblik);
		dodaj(&koren,cvor);
	}
	return koren;
}
void ispis(drvo *p){
	if(p){
		ispis(p->levi);
		printf("%s %s |",p->farba,p->oblik);
		if(p->boja == CRVENA) printf("CRVENA");
		else printf("CRNA");
		ispis(p->desni);
	}
	printf("\n");
}
void brisi(drvo *p,drvo **q,char s[]){
	drvo *pom;
	if(p){
		if(strcmp(p->oblik,s)){
			novi(pom);
			pom->levi = pom->desni = pom->roditelj = NULL;
			strcpy(pom->oblik,p->oblik);
			strcpy(pom->farba,p->farba);
			pom->boja = CRVENA;
			dodaj(q,pom);
		}
		brisi(p->levi,q,s);
		brisi(p->desni,q,s);
	}
	else return;
}
int prebroj(drvo *p,char s[]){
	int d = 0;
	if(p){
		if(!strcmp(p->farba,s)) d++;
		d+=prebroj(p->levi,s);
		d+=prebroj(p->desni,s);
	}
	return d;
}
int main(){
	drvo *koren,*drugi=NULL;
	koren = form();
	ispis(koren);
	printf("oblih na vrhu je %s\n",koren->oblik);
	brisi(koren,&drugi,koren->oblik);
	ispis(drugi);
	printf("boja na vrhu jelke je %s\n",drugi->farba);
	if(prebroj(drugi->levi,drugi->farba) > prebroj(drugi->desni,drugi->farba)) printf("vise te boje ima u levom\n");
	else if (prebroj(drugi->levi,drugi->farba) < prebroj(drugi->desni,drugi->farba)) printf("vise te boje ima u desnom\n");
	else printf("isto\n");
	return 0;
}
	
	
