#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct drvo
{
	char *boja;
	char *oblik;
	int boja1;
	int oblik1;
	int balans;
	struct drvo *levo, *desno;
}drvo;

#define novi(x) x = (drvo *)malloc(sizeof(drvo))
#define nov(x,y) x = (char *)malloc(strlen(y) + 1)

int dubina(drvo *p)
{
	int dd = 0, dl = 0;
	
	if(p)
	{
		if(p->levo) dl = dubina(p->levo);
		if(p->desno) dd = dubina(p->desno);
		if(dd > dl) return ++dd;
		else return ++dl;
	}
	else return 0;
}

void lrotacija(drvo **p)
{
	drvo *poml, *pomd;
	
	poml = *p;
	
	pomd = poml->desno;
	poml->desno = pomd->levo;
	pomd->levo = poml;
	
	*p = pomd;
	
	poml->balans = dubina(poml->desno) - dubina(poml->levo);
	pomd->balans = dubina(pomd->desno) - dubina(pomd->levo);
}


void drotacija(drvo **p)
{
	drvo *poml, *pomd;
	
	pomd = *p;
	
	poml = pomd->levo;
	pomd->levo = poml->desno;
	poml->desno = pomd;
	
	*p = poml;
	
	poml->balans = dubina(poml->desno) - dubina(poml->levo);
	pomd->balans = dubina(pomd->desno) - dubina(pomd->levo);	
}

int boja(char *s)
{
	if(!strcmp(s,"srebrena")) return 1;
	if(!strcmp(s,"crvena")) return 2;
	if(!strcmp(s,"zlatna")) return 3;
}

int oblik(char *s)
{
	if(!strcmp(s,"sfera")) return 1;
	if(!strcmp(s,"kocka")) return 2;	
}

int dodaj(drvo **p, char *s, char *k)
{
	drvo *t;
	int b,o;
	int inkrement, rezultat = 0;
	t = *p;
	
	if(t == NULL)
	{
		novi(t);
		if(t == NULL)
		{
			printf("Greska pri alociranju memorije\n");
			exit(0);
		}
		
		nov(t->boja, s);
		strcpy(t->boja, s);
		
		
		nov(t->oblik, k);
		strcpy(t->oblik, k);
		
		t->levo = t->desno = NULL;
		
		t->balans = 0;
		
		t->boja1 = boja(s);
		t->oblik1 = oblik(k);
		rezultat = 1;
		
	}
	else  
	{
	b = boja(s);
	if(b == t->boja1)
	{	
		o = oblik(k);
		if(o >= t->oblik1) inkrement = dodaj(&(t->desno), s, k);
		else inkrement = -dodaj(&(t->levo), s, k);
	}
	else if(b > t->boja1) inkrement = dodaj(&(t->desno), s, k);
	else inkrement = -dodaj(&(t->levo), s, k); 
	
	t->balans += inkrement;
	
	if(t->balans < -1)
	{
		if(t->levo->balans < 0) drotacija(&t);
		else 
		{
			lrotacija(&(t->levo));
			drotacija(&t);
		}
	}
	else 
	if(t->balans > 1)
	{
		if(t->desno->balans > 0) lrotacija(&t);
		else 
		{
			drotacija(&(t->desno));
			lrotacija(&t);
		}
	}
	else rezultat = 1;
	
	}
	*p = t;
	return rezultat;
	
}

drvo *form(int n)
{
	drvo *p;
	int i;
	char s[30], k[30];
	
	p = NULL;
	
	for(i = 0;i < n; i++)
	{
		printf("Unesite boju:");
		scanf("%s", s);
		printf("Unesite oblik kugle:");
		scanf("%s", k);
		dodaj(&p, s, k);
	}
	
	return p;
}

void ispis(drvo *p)
{
	if(p)
	{
		ispis(p->levo);
		printf("Boja:%s, Obilk:%s, Balans:%d\n",p->boja, p->oblik,p->balans);
		ispis(p->desno);
	}
}

void sredi(drvo **p)
{
	drvo *t;
	
	if(*p)
	{
		t = *p;
		if(t->balans < -1)
		{
			if(t->levo->balans < 0) drotacija(&t);
			else 
			{
				lrotacija(&(t->levo));
				drotacija(&t);
			}
		}
		else 
		if(t->balans > 1)
		{
			if(t->desno->balans > 0) lrotacija(&t);
			else 
			{
				drotacija(&(t->desno));
				lrotacija(&t);
			}
		}
		*p = t;
	}
}

drvo *nadji(drvo **p)
{
	drvo *pom;
	drvo *res;
	
	pom = *p;
	
	if(!pom->levo)
	{
		res = pom;
		pom = pom->desno;
	}
	else res = nadji(&(pom->levo));
	
	if(pom)
	{
		pom->balans = dubina(pom->desno) - dubina(pom->levo);
		sredi(&pom);
	}
	
	*p = pom;
	
	return res;
}

drvo *brisi(drvo *p, char *s)
{
	drvo *pom, *t;
	
	if(!p) return NULL;
	if(p)
	{
		if((!p->levo) && (p->desno))
		{
			free(p);
			return NULL;
		}
		if((!p->levo) && (p->desno))
		{
			pom = p->desno;
			free(p);
			return pom;
		}
		if((p->levo) && (!p->desno))
		{
			pom = p->levo;
			free(p);
			return pom;
		}
		if((p->levo) && (p->desno))
		{
			t = nadji(&(p->desno));
			strcpy(p->boja, t->boja);
			strcpy(p->oblik, t->oblik);
			p->balans = dubina(p->desno) - dubina(p->levo);
			sredi(&p);
			return p;
		}
	}
	p->levo = brisi(p->levo, s);
	p->balans = dubina(p->desno) - dubina(p->levo);
	sredi(&p);
	p->desno = brisi(p->desno, s);
	p->balans = dubina(p->desno) - dubina(p->levo);
	sredi(&p);
	return p;
}

void vrh_jelke(drvo *p)
{
	if(p)
	{	
		printf("%s", p->oblik);
	}
}



main()
{
	drvo *p;
	int n,i;
	char s[30];
	
	printf("Unesite broj ukrasa:");
	scanf("%d",&n);
	
	p = form(n);
	printf("\n");
	ispis(p);	
	
	for(i = 0;i < n; i++)
	p = brisi(p,s);
	
	printf("\n");
	ispis(p);
	
	strcpy(s, p->boja);
	printf("Na vrhu jelke se nalazi:%s\n", s);
	
}
