#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct s_drvo {
	char *boja;
	char *oblik;
	int balans;
	struct s_drvo *levi, *desni;
} DRVO;

#define novi(x) x = (DRVO *)malloc(sizeof(DRVO))

int poredi_boje(char *boja1, char *boja2) {
	if (strcmp(boja1, boja2) == 0) return 0;
	if ((strcmp(boja1, "srebrna") == 0) && (strcmp(boja2, "crvena") == 0)) return -1;
	if ((strcmp(boja1, "srebrna") == 0) && (strcmp(boja2, "zlatna") == 0)) return -1;
	if ((strcmp(boja1, "crvena") == 0) && (strcmp(boja2, "srebrna") == 0)) return 1;
	if ((strcmp(boja1, "crvena") == 0) && (strcmp(boja2, "zlatna") == 0)) return -1;
	if ((strcmp(boja1, "zlatna") == 0) && (strcmp(boja2, "srebrna") == 0)) return 1;
	if ((strcmp(boja1, "zlatna") == 0) && (strcmp(boja2, "crvena") == 0)) return 1;	
}

int poredi_oblik(char *oblik1, char *oblik2) {
	if (strcmp(oblik1, oblik2) == 0) return 0;
	if ((strcmp(oblik1, "sfera") == 0) && (strcmp(oblik2, "kocka") == 0)) return -1;
	if ((strcmp(oblik1, "kocka") == 0) && (strcmp(oblik2, "sfera") == 0)) return 1;
}

int dubina(DRVO *p) {
	int dl, dd;
	dl = dd = 0;
	if (p) {
		if (p->levi) dl = dubina(p->levi);
		if (p->desni) dd = dubina(p->desni);
		if (dl > dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}

void lrotacija(DRVO **t) {
	DRVO *poml, *pomd;
	poml = *t;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*t = pomd;
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(DRVO **t) {
	DRVO *poml, *pomd;
	pomd = *t;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*t = poml;
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

int dodaj(DRVO **p, char *bojaa, char *oblikk) {
	int inkrement, rezultat = 0;
	DRVO *t = *p;
	if (!t) {
		novi(t);
		if (!t) {
			printf("Greska pri alokaciji memorije.\n");
			exit(0);
		}
		t->boja = (char *)malloc(strlen(bojaa) + 1);
		strcpy(t->boja, bojaa);
		t->oblik = (char *)malloc(strlen(oblikk) + 1);
		strcpy(t->oblik, oblikk);
		t->balans = 0;
		t->levi = t->desni = NULL;
		rezultat = 1;
	}
	else {
		if (poredi_boje(bojaa, t->boja) == 0) {
			if (poredi_oblik(oblikk, t->oblik) > 0) inkrement = dodaj(&(t->desni), bojaa, oblikk);
			else inkrement = -dodaj(&(t->levi), bojaa, oblikk);
		}
		else if (poredi_boje(bojaa, t->boja) > 0) inkrement = dodaj(&(t->desni), bojaa, oblikk);
		else inkrement = -dodaj(&(t->levi), bojaa, oblikk);
		t->balans += inkrement;
		if (inkrement != 0 && t->balans != 0) {
			if (t->balans < -1) {
				if (t->levi->balans < 0) drotacija(&t);
				else {
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if (t->balans > 1) {
				if (t->desni->balans > 0) lrotacija(&t);
				else {
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rezultat = 1;
		}
	}
	*p = t;
	return rezultat;
}

void ispis(DRVO *p) {
	if (p) {
		ispis(p->levi);
		printf("%s %s %d\n", p->boja, p->oblik, p->balans);
		ispis(p->desni);
	}
}

void kreiraj_novo(DRVO *p, DRVO **q, char *oblikk) {
	if (p) {
		kreiraj_novo(p->levi, q, oblikk);
		if (strcmp(p->oblik, oblikk) != 0) dodaj(q, p->boja, p->oblik);
		kreiraj_novo(p->desni, q, oblikk);
	}
}

void prebroj(DRVO *p, char *bojaa, int *brojac) {
	if (p) {
		prebroj(p->levi, bojaa, brojac);
		if (strcmp(p->boja, bojaa) == 0) (*brojac)++;
		prebroj(p->desni, bojaa, brojac);
	}
}

main() {
	DRVO *p = NULL;
	DRVO *q = NULL;
	int n, i, levo = 0, desno = 0;
	char bojaa[50], oblikk[50];
	scanf("%d", &n);
	getchar();
	for (i = 0; i < n; i++) {
		gets(bojaa);
		gets(oblikk);
		dodaj(&p, bojaa, oblikk);
	}
	ispis(p);
	printf("Oblik ukrasa na vrhu jelke je: %s\n", p->oblik);
	kreiraj_novo(p, &q, p->oblik);
	ispis(q);
	printf("Boja ukrasa na vrhu jelke je: %s\n", q->boja);
	if (q->levi) prebroj(q->levi, q->boja, &levo);
	if (q->desni) prebroj(q->desni, q->boja, &desno);
	if (levo > desno) printf("Ima vise ukrasa u levom podstablu (L: %d D: %d).\n", levo, desno);
	else if (levo < desno) printf("Ima vise ukrasa u desnom podstablu (L: %d D: %d).\n", levo, desno);
	else printf("Broj ukrasa u levom i desnom podstablu je jednak (L: %d D: %d).\n", levo, desno);
}
