#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct drvo
{
	char *boja;
	char *oblik;
	int balans;
	struct drvo *levi, *desni;
}Drvo;

#define novi(x) x = (Drvo *)malloc(sizeof(Drvo));

int dubina(Drvo *p)
{
	int dd = 0, dl = 0;
	if(p)
	{
		if(p->levi) dl = dubina(p->levi);
		if(p->desni) dd = dubina(p->desni);
		if(dl > dd) return ++dl;
		else return ++dd;
	}else return 0;
}

void lrotacija(Drvo **t)
{
	Drvo *poml, *pomd;
	poml = *t;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*t = pomd;
	poml->balans = dubina(poml->desni)-dubina(poml->levi);
	pomd->balans = dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(Drvo **t)
{
	Drvo *poml, *pomd;
	pomd = *t;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*t = poml;
	poml->balans = dubina(poml->desni)-dubina(poml->levi);
	pomd->balans = dubina(pomd->desni)-dubina(pomd->levi);
}

int pomocna(char *boje)
{
	if(strcmp(boje, "srebrna") == 0) return 1;
	else if(strcmp(boje,"crvena") == 0) return 2;
	else if(strcmp(boje,"zlatna") == 0) return 3;
}

int pomoblik(char *oblici)
{
	if(strcmp(oblici,"sfera")==0) return 1;
	else if(strcmp(oblici,"kocka")==0) return 2;
}
int dodaj(Drvo **p, char *bojaa, char *oblikk)
{
	int inkrement, rezultat = 0;
	Drvo *t = *p;
	if(!t)
	{
		novi(t);
		if(!t)
			perror("Greska pri alokaciji memorije\n");
		t->boja=(char*)malloc(strlen(bojaa)+1);
		strcpy(t->boja,bojaa);
		t->oblik=(char*)malloc(strlen(oblikk)+1);
		strcpy(t->oblik, oblikk);
		t->balans = 0;
		t->levi = t->desni = NULL;
		rezultat = 1;
	}
	else
	{
		if(pomocna(bojaa) > pomocna(t->boja)) inkrement = dodaj(&(t->desni),bojaa,oblikk);
		else if((pomocna(bojaa) == pomocna(t->boja)) && (pomoblik(oblikk) > pomoblik(t->oblik))) inkrement = dodaj(&(t->desni),bojaa, oblikk);
		else inkrement = -dodaj(&(t->levi),bojaa,oblikk);
		t->balans += inkrement;
		if(inkrement!=0 && t->balans != 0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if(t->balans > 1)
			{
				if(t->desni->balans > 0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rezultat = 1;
		}
	}
	*p = t;
	return rezultat;
}

void ispis(Drvo *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("%s (%s)  (%d)\n",p->boja,p->oblik,p->balans);
		ispis(p->desni);
	}
}

void brisi(Drvo *p, Drvo **q,char *oblikB)
{
	if(p)
	{
		brisi(p->levi,q,oblikB);
		if(strcmp(oblikB,p->oblik) != 0)
		dodaj(q,p->boja, p->oblik);
		brisi(p->desni,q,oblikB);
	}
}

int prebrojLevi(Drvo *q, char *bojaa, int *ukl)
{
	int s;
	if(q) {
		prebrojLevi(q->levi,bojaa,ukl);
		if(strcmp(q->boja,bojaa)==0) *ukl++; 
		}
	return *ukl;
}

int prebrojDesni(Drvo *q, char *bojaa, int *ukd)
{
	int s;
	if(q) {
		prebrojLevi(q->desni,bojaa,ukd);
		if(strcmp(q->boja,bojaa)==0) *ukd++; 
		}
	return *ukd;
}

main()
{
	Drvo *p = NULL;
	Drvo *q = NULL;
	int n, i, ukl = 0, ukd = 0, levi, desni;
	char bojaa[50], oblikk[50], zabrisanje[50];
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		scanf("%s%s",bojaa,oblikk);
		dodaj(&p,bojaa,oblikk);
	}
	ispis(p);
	printf("Ukras na vrhu jelke je: %s %s\n",p->boja, p->oblik);
	strcpy(zabrisanje,p->oblik);
	printf("brisemo sve oblike %s\n",zabrisanje);
	brisi(p,&q,zabrisanje);
	printf("\n--------------------------------------------------------------\n");
	printf("posle brisanja: \n");
	ispis(q);
	printf("Sada je na vrhu jelke %s %s\n",q->boja, q->oblik);
	char bojaU[50];
	strcpy(bojaU,q->boja);
	levi = prebrojLevi(q,bojaU,&ukl);
	printf("levo podstablo ima:  %d\n",levi);
	desni = prebrojDesni(q,bojaU,&ukd);
	printf("Desni %d\n",desni);
	
}
